﻿using System.Windows.Forms;
using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication4
{
    public partial class Form1 : Form
    {
        private UltraDataSource source;
        private UltraGrid grid;

        public Form1()
        {
            InitializeComponent();

            this.source = new UltraDataSource();
            this.source.CellDataRequested += new CellDataRequestedEventHandler(Source_CellDataRequested);
            this.source.Rows.SetCount(1);

            this.grid = new UltraGrid();
            this.Controls.Add(this.grid);
            this.grid.Dock = DockStyle.Fill;
            this.grid.DataSource = this.source;

            for (int i = 0; i < 100; i++)
            {
                this.AddColumn(i.ToString());
            }

            this.grid.DisplayLayout.LoadStyle = LoadStyle.LoadOnDemand;

            this.grid.DisplayLayout.UseFixedHeaders = true;
        }

        private void AddColumn(string strKey)
        {
            this.source.Band.Columns.Add(strKey);
            UltraGridGroup group = this.grid.DisplayLayout.Bands[0].Groups.Add(strKey);
            group.Columns.Add(this.grid.DisplayLayout.Bands[0].Columns[strKey]);
        }

        private void Source_CellDataRequested(object sender, CellDataRequestedEventArgs e)
        {
            e.Data = e.Column.Key + ", " + e.Row.Index.ToString();
        }
    }
}